{% set current_role = topology.roles.get(current_group_role) %}
# Authoritative, validating, recursive caching DNS
server:
    # Sets unbound to send log messages to the syslogd, using syslog(3). The
    # log facility LOG_DAEMON is used, with identity "unbound". The logfile
    # setting is overridden when use-syslog is turned on. The default is to log
    # to syslog.
    #
    # use-syslog: <yes or no>
    use-syslog: yes

    # The verbosity number, level 0 means no verbosity, only errors. Level 1
    # gives operational information. Level 2 gives detailed operational
    # information. Level 3 gives query level information, output per query.
    # Level 4 gives algorithm level information. Level 5 logs client
    # identification for cache misses. Default is level 1. The verbosity can
    # also be increased from the commandline, see _unbound(8)_.
    #
    # verbosity: <number>
    verbosity: 1

    # Interface to use to connect to the network. This interface is listened to
    # for queries from clients, and answers to clients are given from it. Can
    # be given multiple times to work on several interfaces. If none are given
    # the default is to listen to localhost. The interfaces are not changed on
    # a reload (kill -HUP) but only on restart. A port number can be specified
    # with @port (without spaces between interface and port number), if not
    # specified the default port (from **port**) is used.
    #
    # interface: <ip address[@port]>
    interface: 127.0.0.1
{% for interface_name in current_role.interfaces %}
{% set interface = current_role.interfaces.get(interface_name) %}
{% if interface.dhcp_server == true %}
    interface: {{ interface.ip }}
{% endif %}
{% endfor %}

    # Interface to use to connect to the network. This interface is used to
    # send queries to authoritative servers and receive their replies. Can be
    # given multiple times to work on several interfaces. If none are given the
    # default (all) is used. You can specify the same interfaces in
    # **interface:** and **outgoing-interface:** lines, the interfaces are then
    # used for both purposes. Outgoing queries are sent via a random outgoing
    # interface to counter spoofing.
    #
    # If an IPv6 netblock is specified instead of an individual IPv6 address,
    # outgoing UDP queries will use a randomised source address taken from the
    # netblock to counter spoofing. Requires the IPv6 netblock to be routed to
    # the host running unbound, and requires OS support for unprivileged
    # non-local binds (currently only supported on Linux). Several netblocks
    # may be specified with multiple **outgoing-interface:** options, but do
    # not specify both an individual IPv6 address and an IPv6 netblock, or the
    # randomisation will be compromised. Consider combining with
    # **prefer-ip6: yes** to increase the likelihood of IPv6 nameservers being
    # selected for queries. On Linux you need these two commands to be able to
    # use the freebind socket option to receive traffic for the ip6 netblock:
    # ip -6 addr add mynetblock/64 dev lo && ip -6 route add local
    # mynetblock/64 dev lo.
    #
    # outgoing-interface: <ip address or ip6 netblock>
    outgoing-interface: {{ ansible_default_ipv4.address }}

    # The port number, default 53, on which the server responds to queries.
    #
    # port: <port number>
    port: 53

    # Enable or disable whether ip4 queries are answered or issued. Default is
    # yes.
    #
    # do-ip4: <yes or no>
    do-ip4: yes

    # Enable or disable whether ip6 queries are answered or issued. Default is
    # yes. If disabled, queries are not answered on IPv6, and queries are not
    # sent on IPv6 to the internet nameservers. With this option you can
    # disable the ipv6 transport for sending DNS traffic, it does not impact
    # the contents of the DNS traffic, which may have ip4 and ip6 addresses in
    # it.
    #
    # do-ip6: <yes or no>
    do-ip6: no

    # Enable or disable whether UDP queries are answered or issued. Default is
    # yes.
    #
    # do-udp: <yes or no>
    do-udp: yes

    # Enable or disable whether TCP queries are answered or issued. Default is
    # yes.
    #
    # Additional notes:
    # If TCP is not needed, unbound is actually quicker to resolve as the
    # functions related to TCP checks are not done.
    #
    # You may need TCP enabled to get the DNSSEC results from *.edu domains due
    # to their size.
    #
    # do-tcp: <yes or no>
    do-tcp: yes

    # The netblock is given as an IP4 or IP6 address with /size appended for a
    # classless network block. The action can be _deny_, _refuse_, _allow_,
    # _allow_setrd_, _allow_snoop_, _deny_non_local_ or _refuse_non_local_. The
    # most specific netblock match is used, if none match _deny_ is used.
    #
    # The action _deny_ stops queries from hosts from that netblock.
    #
    # The action _refuse_ stops queries too, but sends a DNS rcode REFUSED
    # error message back.
    #
    # The action _allow_ gives access to clients from that netblock. It gives
    # only access for recursion clients (which is what almost all clients
    # need). Nonrecursive queries are refused.
    #
    # The _allow_ action does allow nonrecursive queries to access the
    # local-data that is configured. The reason is that this does not involve
    # the unbound server recursive lookup algorithm, and static data is served
    # in the reply. This supports normal operations where nonrecursive queries
    # are made for the authoritative data. For nonrecursive queries any replies
    # from the dynamic cache are refused.
    #
    # The _allow_setrd_ action ignores the recursion desired (RD) bit and
    # treats all requests as if the recursion desired bit is set. Note that
    # this behavior violates RFC 1034 which states that a name server should
    # never perform recursive service unless asked via the RD bit since this
    # interferes with trouble shooting of name servers and their databases.
    # This prohibited behavior may be useful if another DNS server must forward
    # requests for specific zones to a resolver DNS server, but only supports
    # stub domains and sends queries to the resolver DNS server with the RD bit
    # cleared.
    #
    # The action _allow_snoop_ gives nonrecursive access too. This give both
    # recursive and non recursive access. The name _allow_snoop_ refers to
    # cache snooping, a technique to use nonrecursive queries to examine the
    # cache contents (for malicious acts). However, nonrecursive queries can
    # also be a valuable debugging tool (when you want to examine the cache
    # contents). In that case use _allow_snoop_ for your administration host.
    #
    # By default only localhost is _allowed_, the rest is _refused_. The
    # default is _refused_, because that is protocol-friendly. The DNS protocol
    # is not designed to handle dropped packets due to policy, and dropping may
    # result in (possibly excessive) retried queries.
    #
    # The _deny_non_local_ and _refuse_non_local_ settings are for hosts that
    # are only allowed to query for the authoritative local-data, they are not
    # allowed full recursion but only the static data. With _deny_non_local_,
    # messages that are disallowed are dropped, with _refuse_non_local_ they
    # receive error code REFUSED. 
    #
    # access-control: <IP netblock> <action>
    access-control: 127.0.0.0/8 allow
{% for interface_name in current_role.interfaces %}
{% set interface = current_role.interfaces.get(interface_name) %}
{% if interface.dhcp_server == true %}
    access-control: {{ interface.netblock }} allow
{% endif %}
{% endfor %}

    # Read the root hints from this file. Default is nothing, using builtin
    # hints for the IN class. The file has the format of zone files, with root
    # nameserver names and addresses only. The default may become outdated,
    # when servers change, therefore it is good practice to use a root-hints
    # file.
    #
    # Additional notes:
    # https://www.internic.net/domain/named.root
    #
    # root-hints: <filename>
    root-hints: "/var/unbound/etc/root.hints"

    # If enabled id.server and hostname.bind queries are refused.
    #
    # hide-identity: <yes or no>
    hide-identity: yes

    # If enabled version.server and version.bind queries are refused.
    #
    # hide-version: <yes or no>
    hide-version: yes

    # Will trust glue only if it is within the servers authority. Default is
    # on.
    #
    # Additional notes:
    # Harden against out of zone RRsets, to avoid spoofing attempts. Hardening
    # queries multiple name servers for the same data to make spoofing
    # significantly harder and does not mandate DNSSEC.
    #
    # harden-glue: <yes or no>
    harden-glue: yes

    # Require DNSSEC data for trust-anchored zones, if such data is absent, the
    # zone becomes bogus. If turned off, and no DNSSEC data is received (or the
    # DNSKEY data fails to validate), then the zone is made insecure, this
    # behaves like there is no trust anchor. You could turn this off if you are
    # sometimes behind an intrusive firewall (of some sort) that removes DNSSEC
    # data from packets, or a zone changes from signed to unsigned to badly
    # signed often. If turned off you run the risk of a downgrade attack that
    # disables security for a zone. Default is on.
    #
    # harden-dnssec-stripped: <yes or no>
    harden-dnssec-stripped: yes

    # Use 0x20-encoded random bits in the query to foil spoof attempts. This
    # perturbs the lowercase and uppercase of query names sent to authority
    # servers and checks if the reply still has the correct casing. Disabled
    # by default. This feature is an experimental implementation of draft
    # dns-0x20.
    #
    # Additional notes:
    # http://tools.ietf.org/html/draft-vixie-dnsext-dns0x20-00
    # While upper and lower case letters are allowed in domain names, no
    # significance is attached to the case. That is, two names with the same
    # spelling but different case are to be treated as if identical. This means
    # calomel.org is the same as CaLoMeL.Org which is the same as CALOMEL.ORG.
    #
    # use-caps-for-id: <yes or no>
    use-caps-for-id: yes

    # Time to live minimum for RRsets and messages in the cache. Default is 0.
    # If the minimum kicks in, the data is cached for longer than the domain
    # owner intended, and thus less queries are made to look up the data. Zero
    # makes sure the data in the cache is as the domain owner intended, higher
    # values, especially more than an hour or so, can lead to trouble as the
    # data in the cache does not match up with the actual data any more.
    #
    # Additional notes:
    # If more than an hour could easily give trouble due to stale data.
    #
    # cache-min-ttl: <seconds>
    cache-min-ttl: 1200

    # Time to live maximum for RRsets and messages in the cache. Default is
    # 86400 seconds (1 day). If the maximum kicks in, responses to clients
    # still get decrementing TTLs based on the original (larger) values. When
    # the internal TTL expires, the cache item has expired. Can be set lower to
    # force the resolver to query for data often, and not trust (very large)
    # TTL values.
    #
    # cache-max-ttl: <seconds>
    cache-max-ttl: 28800

    # If yes, message cache elements are prefetched before they expire to keep
    # the cache up to date. Default is no. Turning it on gives about 10 percent
    # more traffic and load on the machine, but popular items do not expire
    # from the cache.
    #
    # Additional notes:
    # Perform prefetching of close to expired message cache entries. If a
    # client requests the dns lookup and the TTL of the cached hostname is
    # going to expire in less than 10% of its TTL, unbound will (1st) return
    # the ip of the host to the client and (2nd) pre-fetch the dns request from
    # the remote dns server. This method has been shown to increase the amount
    # of cached hits by local clients by 10% on average.
    #
    # prefetch: <yes or no>
    prefetch: yes

    # If yes, fetch the DNSKEYs earlier in the validation process, when a DS
    # record is encountered. This lowers the latency of requests. It does use a
    # little more CPU. Also if the cache is set to 0, it is no use. Default is
    # no.
    #
    # prefetch-key: <yes or no>
    prefetch-key: yes

    # If yes, Unbound rotates RRSet order in response (the random number is
    # taken from the query ID, for speed and thread safety). Default is no.
    #
    # rrset-roundrobin: <yes or no>
    rrset-roundrobin: yes

    # The number of threads to create to serve clients. Use 1 for no threading.
    #
    # Additional notes:
    # This should equal the number of CPU cores in the machine.
    #
    # num-threads: <number>
    num-threads: {{ current_role.unbound.num_threads }}

    ###########################################################################
    ## Unbound Optimization and Speed Tweaks ###

    # Number of slabs in the message cache. Slabs reduce lock contention by
    # threads. Must be set to a power of 2. Setting (close) to the number of
    # cpus is a reasonable guess.
    #
    # Additional notes:
    # More slabs reduce lock contention, but fragment memory usage.
    #
    # msg-cache-slabs: <number>
    msg-cache-slabs: {{ current_role.unbound.cache_slabs }}

    # Number of slabs in the RRset cache. Slabs reduce lock contention by
    # threads. Must be set to a power of 2.
    #
    # Additional notes:
    # More slabs reduce lock contention, but fragment memory usage.
    #
    # rrset-cache-slabs: <number>
    rrset-cache-slabs: {{ current_role.unbound.cache_slabs }}

    # Number of slabs in the infrastructure cache. Slabs reduce lock contention
    # by threads. Must be set to a power of 2.
    #
    # Additional notes:
    # More slabs reduce lock contention, but fragment memory usage.
    #
    # infra-cache-slabs: <number>
    infra-cache-slabs: {{ current_role.unbound.cache_slabs }}

    # Number of slabs in the key cache. Slabs reduce lock contention by
    # threads. Must be set to a power of 2. Setting (close) to the number of
    # cpus is a reasonable guess.
    #
    # Additional notes:
    # More slabs reduce lock contention, but fragment memory usage.
    #
    # key-cache-slabs: <number>
    key-cache-slabs: {{ current_role.unbound.cache_slabs }}

    # Number of bytes size of the RRset cache. Default is 4 megabytes. A plain
    # number is in bytes, append 'k', 'm' or 'g' for kilobytes, megabytes or
    # gigabytes (1024*1024 bytes in a megabyte).
    #
    # Additional notes:
    # Use roughly twice as much rrset cache memory as you use msg cache memory.
    # Due to malloc overhead, the total memory usage is likely to rise to
    # double (or 2.5x) the total cache memory.
    #
    # rrset-cache-size: <number>
    rrset-cache-size: {{ current_role.unbound.rrset_cache_size }}

    # Number of bytes size of the message cache. Default is 4 megabytes. A
    # plain number is in bytes, append 'k', 'm' or 'g' for kilobytes, megabytes
    # or gigabytes (1024*1024 bytes in a megabyte).
    #
    # Additional notes:
    # Use roughly twice as much rrset cache memory as you use msg cache memory.
    # Due to malloc overhead, the total memory usage is likely to rise to
    # double (or 2.5x) the total cache memory.
    #
    # rrset-cache-size: <number>
    msg-cache-size: {{ current_role.unbound.msg_cache_size }}

    # If not 0, then set the SO_RCVBUF socket option to get more buffer space
    # on UDP port 53 incoming queries. So that short spikes on busy servers do
    # not drop packets (see counter in netstat -su). Default is 0 (use system
    # value). Otherwise, the number of bytes to ask for, try "4m" on a busy
    # server. The OS caps it at a maximum, on linux unbound needs root
    # permission to bypass the limit, or the admin can use sysctl
    # net.core.rmem_max. On BSD change kern.ipc.maxsockbuf in /etc/sysctl.conf.
    # On OpenBSD change header and recompile kernel. On Solaris ndd -set
    # /dev/udp udp_max_buf 8388608.
    #
    # so-rcvbuf: <number>
    so-rcvbuf: 0

    ## Unbound Optimization and Speed Tweaks ###
    ###########################################################################


    # Give IPv4 of IPv6 addresses or classless subnets. These are addresses on
    # your private network, and are not allowed to be returned for public
    # internet names. Any occurrence of such addresses are removed from DNS
    # answers. Additionally, the DNSSEC validator may mark the answers bogus.
    # This protects against so-called DNS Rebinding, where a user browser is
    # turned into a network proxy, allowing remote access through the browser
    # to other parts of your private network. Some names can be allowed to
    # contain your private addresses, by default all the **local-data** that
    # you configured is allowed to, and you can specify additional names using
    # **private-domain**. No private addresses are enabled by default. We
    # consider to enable this for the RFC1918 private IP address space by
    # default in later releases. That would enable private addresses for
    # 10.0.0.0/8 172.16.0.0/12 192.168.0.0/16 169.254.0.0/16 fd00::/8 and
    # fe80::/10, since the RFC standards say these addresses should not be
    # visible on the public internet. Turning on 127.0.0.0/8 would hinder many
    # spamblocklists as they use that. Adding ::ffff:0:0/96 stops IPv4-mapped
    # IPv6 addresses from bypassing the filter.
    #
    # private-address: <IP address or subnet>
    #private-address: 0.0.0.0/8
    private-address: 10.0.0.0/8
    #private-address: 127.0.0.0/8
    private-address: 169.254.0.0/16
    private-address: 172.16.0.0/12
    private-address: 192.0.0.0/24
    private-address: 192.0.2.0/24
    private-address: 192.88.99.0/24
    private-address: 192.168.0.0/16
    private-address: 198.18.0.0/15
    private-address: 198.51.100.0/24
    private-address: 203.0.113.0/24

    # Allow this domain, and all its subdomains to contain private addresses.
    # Give multiple times to allow multiple domain names to contain private
    # addresses. Default is none.
    #
    # Additional notes:
    # local-data statements are allowed to contain private addresses too.
    #
    # private-domain: <domain name>
    private-domain: "{{ topology.domain_name }}"

    # If set, a total number of unwanted replies is kept track of in every
    # thread. When it reaches the threshold, a defensive action is taken and a
    # warning is printed to the log. The defensive action is to clear the rrset
    # and message caches, hopefully flushing away any poison. A value of 10
    # million is suggested. Default is 0 (turned off).
    #
    # Additional notes:
    # We think 10K is a good value.
    #
    # unwanted-reply-threshold: <number>
    unwanted-reply-threshold: 10000

    # If yes, localhost is added to the do-not-query-address entries, both IP6
    # ::1 and IP4 127.0.0.1/8. If no, then localhost can be used to send
    # queries to. Default is yes.
    #
    # Additional notes:
    # IMPORTANT FOR TESTING: If you are testing and setup NSD or BIND on
    # localhost you will want to allow the resolver to send queries to
    # localhost. Make sure to set do-not-query-localhost: yes. If yes, the
    # above default do-not-query-address entries are present. If no, localhost
    # can be queried (for testing and debugging).
    #
    # do-not-query-localhost: <yes or no>
    do-not-query-localhost: no

{% if hostvars['eru.home.lan']['ENV_DNS_FORWARDING'].stat.exists == false %}
    # File with trust anchor for one zone, which is tracked with RFC5011
    # probes. The probes are several times per month, thus the machine must be
    # online frequently. The initial file can be one with contents as described
    # in **trust-anchor-file**. The file is written to when the anchor is
    # updated, so the unbound user must have write permission. Write permission
    # to the file, but also to the directory it is in (to create a temporary
    # file, which is necessary to deal with filesystem full events), it must
    # also be inside the chroot (if that is used).
    #
    # Additional notes:
    # Use several entries, one per domain name, to track multiple zones. If you
    # use forward-zone below to query the Google DNS servers you MUST comment
    # out this option or all DNS queries will fail.
    #
    # auto-trust-anchor-file: <filename>
    auto-trust-anchor-file: "/var/unbound/db/root.key"

{% endif %}
    # Instruct the validator to remove data from the additional section of
    # secure messages that are not signed properly. Messages that are insecure,
    # bogus, indeterminate or unchecked are not affected. Default is yes. Use
    # this setting to protect the users that rely on this validator for
    # authentication from potentially bad data in the additional section.
    #
    # val-clean-additional: <yes or no>
    val-clean-additional: yes

{% if hostvars['eru.home.lan']['ENV_DNS_FORWARDING'].stat.exists == false %}
    # Files can be included using the **include**: directive. It can appear
    # anywhere, it accepts a single file name as argument. Processing continues
    # as if the text from the included file was copied into the config file at
    # that point. If also using chroot, using full path names for the included
    # files works, relative pathnames for the included names work if the
    # directory where the daemon is started equals its chroot/working directory
    # or is specified before the include statement with directory: dir.
    # Wildcards can be used to include multiple files, see _glob(7)_.
    #
    # Additional notes:
    # Unbound will not load if you specify the same local-zone and local-data
    # servers in the main configuration as well as in this "include:" file. We
    # suggest commenting out any of the local-zone and local-data lines above
    # if you suspect they could be included in the unbound_ad_servers servers
    # file.
    #
    # include: <file>
    include: "/var/unbound/etc/unbound_ad_servers.conf"

{% endif %}
    # Locally served zones can be configured for the machines on the LAN.
    local-zone: "{{ topology.domain_name }}." static

{% for interface_name in current_role.interfaces %}
{% set interface = current_role.interfaces.get(interface_name) %}
{% if interface.name == "LAN" %}
    local-data: "{{ current_role.hostname }}.{{ topology.domain_name }}. IN A {{ interface.ip }}"
    local-data-ptr: "{{ interface.ip }} {{ current_role.hostname }}.{{ topology.domain_name }}"
{% endif %}
{% endfor %}

{% for interface_name in current_role.interfaces %}
{% set interface = current_role.interfaces.get(interface_name) %}
{% if interface.dhcp_server == true %}
{% if "fixed_address" in interface %}
{% for key, value in interface.fixed_address.items() %}
    local-data: "{{ topology.roles[key].hostname }}.{{ topology.domain_name }}. IN A {{ value.ip }}"
    local-data-ptr: "{{ value.ip }} {{ topology.roles[key].hostname }}.{{ topology.domain_name }}"

{% endfor %}
{% endif %}
{% endif %}
{% endfor %}
{% if hostvars['eru.home.lan']['ENV_DNS_FORWARDING'].stat.exists == true %}
    forward-zone:
        name: "."
        forward-addr: 192.99.85.244   # OpenNIC
        forward-addr: 172.98.193.42   # OpenNIC

{% endif %}
